@echo off
rem program name
set currentuserpendingprogramfulldirnquotes=%0
set currentuserpendingprogramdirectory=%cd%
call set currentuserpendingprogramnopath=%%currentuserpendingprogramfulldirnquotes:%currentuserpendingprogramdirectory%\=%%
set currentuserpendingprogramfull=%currentuserpendingprogramnopath:"=%
set currentuserpendingprogram=%currentuserpendingprogramfull:.cmd=%
set currentuserpendingprogramvbs=%currentuserpendingprogram%.vbs
set currentuserpendingprogramcmd=%currentuserpendingprogram%.cmd
rem ----------------
echo (..  ..  ..  ..  ..  ..  ..  ..)
echo (  ..  ..  ..  ..  ..  ..  ..  )
echo %date% %time%
echo Running program: %currentuserpendingprogramcmd%
echo Located in directory: %currentuserpendingprogramdirectory%
echo (..  ..  ..  ..  ..  ..  ..  ..)
echo (  ..  ..  ..  ..  ..  ..  ..  )
setlocal EnableDelayedExpansion
rem ---
rem win64 curl directory
rem set userpendinglibcurldir=.\curl-7.21.0-win64-ssl-sspi
rem ---
rem win32 curl directory
set defuserpendinglibcurldir=.\curl-7.21.1-ssl-sspi-zlib-static-bin-w32
rem ---
rem boinc website
set defuserpendingboincsiteurl=where_are_we_going_to_go
rem ---
rem boinc login user
set defuserpendingboincloginuser=usernotset
rem ---
rem boinc login password
set defuserpendingboincloginpassword=passwordnotset
rem ---
rem md5 directory
set defuserpendingmd5directoryprogram=.\md5\md5.exe
rem ---
rem win32 choose directory
set defuserpendingchoosedirectoryprogram=.\editv22\choose32.exe
rem ---
rem temp authenticator file
set defuserpendingboincauthfile=.\boinc-user-auth.ini
rem ---
rem pending output file
set defuserpendingboincpendingfile=nothing
rem (set userpendingboincpendingfile=)
rem ---
rem Default ini
set defuserpendinginidirectoryfilename=.\%currentuserpendingprogram%-control.ini
rem ---
rem output format filler
set userpendingoutputfiller=`````````````````````````````````````````````````````````````````````````````````````
rem ---
rem put value here
set userpendingputvaluehere=70
rem ---
rem default stop run
set defuserpendingstoprun=no
rem ---
rem default end of batch program pause
set defuserpendingpauserunofbatch=60
rem ---
rem default run with
set defuserpendingrunwith=call
rem ---
rem Test flag
set defuserpendingtestrun=no
set userpendingruncomdtext=echo Run this command:
set userpendingrunflag=yes
rem ---

:: info request
if [%1]==[/?] goto :reqinfo
if [%2]==[/?] goto :reqinfo
if [%3]==[/?] goto :reqinfo
if [%4]==[/?] goto :reqinfo
if [%5]==[/?] goto :reqinfo
if [%6]==[/?] goto :reqinfo

:: passed args
if not [%1]==[] set userpendingparseargprm1=%1
if not [%2]==[] set userpendingparseargprm2=%2
if not [%3]==[] set userpendingparseargprm3=%3
if not [%4]==[] set userpendingparseargprm4=%4
if not [%5]==[] set userpendingparseargprm5=%5
if not [%6]==[] set userpendingparseargprm6=%6
rem ---
echo -------------------
echo Processing Arg Input Start
rem ini directory and filename

call :processarginput /inidirectoryfilename: %defuserpendinginidirectoryfilename% userpendinginidirectoryfilename notoktosetvaluetoparms userpendingprgmparms1

rem ---
rem Run with start

call :processarginput /runwith: %defuserpendingrunwith% userpendingrunwith notoktosetvaluetoparms userpendingprgmparms2

rem ---
rem test run

call :processarginput /testrun: %defuserpendingtestrun% userpendingtestrun notoktosetvaluetoparms userpendingprgmparms3

rem ----------------

if %userpendingtestrun% equ yes echo Running Test
if %userpendingtestrun% neq yes (set userpendingruncomdtext=)
if %userpendingtestrun% neq yes (set userpendingrunflag=)
echo Processing Arg Input Complete

rem process according to control file
echo -------------------
echo Processing Control ini file Start

set userpendingcontroltempini=.\%currentuserpendingprogram%-control-temp.ini
if not exist %userpendinginidirectoryfilename% goto :noinifile
if exist %userpendinginidirectoryfilename% type %userpendinginidirectoryfilename% > %userpendingcontroltempini%
goto :gotinifile

:noinifile
echo The INI file specified in above variable inidirectoryfilename missing value: %userpendinginidirectoryfilename%
goto :skipprocessitini

:gotinifile
FOR /F "tokens=1,2 delims=;" %%A IN (%userpendingcontroltempini%) DO (
call :processitini %%A %%B
)

:skipprocessitini
if exist %userpendingcontroltempini% (del %userpendingcontroltempini%)

:: set default curl directory value
if not defined userpendinglibcurldir (set userpendingoutputpart1=No value read from ini using default userpendinglibcurldir)
if not defined userpendinglibcurldir (set userpendingoutputpart2=value: %defuserpendinglibcurldir%)
if not defined userpendinglibcurldir call :eocuhtotheline
if not defined userpendinglibcurldir (set userpendinglibcurldir=%defuserpendinglibcurldir%)


:: set default boinc website value
if not defined userpendingboincsiteurl (set userpendingoutputpart1=No value read from ini using default userpendingboincsiteurl)
if not defined userpendingboincsiteurl (set userpendingoutputpart2=value: %defuserpendingboincsiteurl%)
if not defined userpendingboincsiteurl call :eocuhtotheline
if not defined userpendingboincsiteurl (set userpendingboincsiteurl=%defuserpendingboincsiteurl%)


:: set default boinc login user value
if not defined userpendingboincloginuser (set userpendingoutputpart1=No value read from ini using default userpendingboincloginuser)
if not defined userpendingboincloginuser (set userpendingoutputpart2=value: %defuserpendingboincloginuser%)
if not defined userpendingboincloginuser call :eocuhtotheline
if not defined userpendingboincloginuser (set userpendingboincloginuser=%defuserpendingboincloginuser%)


:: set default boinc login password value
if not defined userpendingboincloginpassword (set userpendingoutputpart1=No value read from ini using default userpendingboincloginpassword)
if not defined userpendingboincloginpassword (set userpendingoutputpart2=value: %defuserpendingboincloginpassword%)
if not defined userpendingboincloginpassword call :eocuhtotheline
if not defined userpendingboincloginpassword (set userpendingboincloginpassword=%defuserpendingboincloginpassword%)


:: set default md5 directory value
if not defined userpendingmd5directoryprogram (set userpendingoutputpart1=No value read from ini using default userpendingmd5directoryprogram)
if not defined userpendingmd5directoryprogram (set userpendingoutputpart2=value: %defuserpendingmd5directoryprogram%)
if not defined userpendingmd5directoryprogram call :eocuhtotheline
if not defined userpendingmd5directoryprogram (set userpendingmd5directoryprogram=%defuserpendingmd5directoryprogram%)


:: set default choose directory value
if not defined userpendingchoosedirectoryprogram (set userpendingoutputpart1=No value read from ini using default userpendingchoosedirectoryprogram)
if not defined userpendingchoosedirectoryprogram (set userpendingoutputpart2=value: %defuserpendingchoosedirectoryprogram%)
if not defined userpendingchoosedirectoryprogram call :eocuhtotheline
if not defined userpendingchoosedirectoryprogram (set userpendingchoosedirectoryprogram=%defuserpendingchoosedirectoryprogram%)


:: set default temp authenticator file value
if not defined userpendingboincauthfile (set userpendingoutputpart1=No value read from ini using default userpendingboincauthfile)
if not defined userpendingboincauthfile (set userpendingoutputpart2=value: %defuserpendingboincauthfile%)
if not defined userpendingboincauthfile call :eocuhtotheline
if not defined userpendingboincauthfile (set userpendingboincauthfile=%defuserpendingboincauthfile%)


:: set default pending output file value
if not defined userpendingboincpendingfile (set userpendingoutputpart1=No value read from ini using default userpendingboincpendingfile)
if not defined userpendingboincpendingfile (set userpendingoutputpart2=value: %defuserpendingboincpendingfile%)
if not defined userpendingboincpendingfile call :eocuhtotheline
if not defined userpendingboincpendingfile (set userpendingboincpendingfile=%defuserpendingboincpendingfile%)
if [%userpendingboincpendingfile%] equ [nothing] (set userpendingboincpendingfile=)
if [%userpendingboincpendingfile%] neq [] set userpendingcurlpendingfile=--output %userpendingboincpendingfile%


:: set default end of batch program pause value
if not defined userpendingpauserunofbatch (set userpendingoutputpart1=No value read from ini using default userpendingpauserunofbatch)
if not defined userpendingpauserunofbatch (set userpendingoutputpart2=value: %defuserpendingpauserunofbatch%)
if not defined userpendingpauserunofbatch call :eocuhtotheline
if not defined userpendingpauserunofbatch (set userpendingpauserunofbatch=%defuserpendingpauserunofbatch%)


:: set default stop run value
if not defined userpendingstoprun (set boincvlarsuspendoutputpart1=No value read from ini using default stoprun)
if not defined userpendingstoprun (set boincvlarsuspendoutputpart2=value: %defboincvlarsuspendstoprun%)
if not defined userpendingstoprun call :eocuhtotheline
if not defined userpendingstoprun (set userpendingstoprun=%defuserpendingstoprun%)

echo Processing Control ini file Complete
rem ----------------

echo -------------------

echo (..  ..  ..  ..  ..  ..  ..  ..)
echo (  ..  ..  ..  ..  ..  ..  ..  )
echo %date% %time%
echo Running program: %currentuserpendingprogramcmd%
echo Located in directory: %currentuserpendingprogramdirectory%
echo (..  ..  ..  ..  ..  ..  ..  ..)
echo (  ..  ..  ..  ..  ..  ..  ..  )

echo Running with this Boinc login user: %userpendingboincloginuser%
echo to access this Boinc site: %userpendingboincsiteurl%
echo. 

set userpendingfounderror=no
rem set the curl value
if not exist %userpendinglibcurldir% echo Missing curl.exe file Looking for it here=%userpendinglibcurldir%
if not exist %userpendinglibcurldir% set userpendingfounderror=yes
rem set boinc user
if [%userpendingboincloginuser%] equ [usernotset] echo Boinc Login User was not set
if not exist %userpendinglibcurldir% set userpendingfounderror=yes
if [%userpendingboincloginuser%] equ [set-your-boinc-userid] echo Boinc Login User was not set
if not exist %userpendinglibcurldir% set userpendingfounderror=yes
rem set boinc password
if [%userpendingboincloginpassword%] equ [passwordnotset] echo Boinc Login Password was not set
if not exist %userpendinglibcurldir% set userpendingfounderror=yes
if [%userpendingboincloginpassword%] equ [set-your-boinc-login-password] echo Boinc Login Password was not set
if not exist %userpendinglibcurldir% set userpendingfounderror=yes
rem set the md5 value
if not exist %userpendingmd5directoryprogram% echo Missing md5.exe file Looking for it here=%userpendingmd5directoryprogram%
if not exist %userpendinglibcurldir% set userpendingfounderror=yes
rem set the choose value
if not exist %userpendingchoosedirectoryprogram% echo Missing choose32 or 64 .exe file Looking for it here=%userpendingchoosedirectoryprogram%
if not exist %userpendingchoosedirectoryprogram% set userpendingfounderror=yes
rem if not exist %userpendingmd5directoryprogram% goto :didnotgetauth
if [%userpendingfounderror%] equ [yes] goto :didnotgetauth
rem md5 options
set userpendingmd5programoptions=-l -d%userpendingboincloginpassword%%userpendingboincloginuser%
rem run md5
set userpendingmd5programrun=%userpendingmd5directoryprogram% %userpendingmd5programoptions%
rem echo %userpendingmd5programrun%
if [%userpendingrunflag%] NEQ [] echo Run this command: %userpendingmd5programrun%
if [%userpendingrunflag%] NEQ [] goto :runtestskipauth
for /f "tokens=1" %%G in ('%userpendingmd5programrun%') DO set userpendingboincmd5hash=%%G
rem echo md5 hash=%userpendingboincmd5hash%
:runtestskipauth
if [%userpendingrunflag%] NEQ [] set userpendingboincmd5hash=testrunblahtestrunblahtestrunblah

rem contact Boinc project website
echo Contacting Boinc project website to get authenticator code
echo.
if not exist %userpendinglibcurldir%\curl.exe echo Missing curl.exe file. Looking for it here=%userpendinglibcurldir%\curl.exe
if not exist %userpendinglibcurldir%\curl.exe goto :didnotgetauth
echo %userpendinglibcurldir%\curl.exe --output %userpendingboincauthfile% %userpendingboincsiteurl%/lookup_account.php?email_addr=%userpendingboincloginuser%^&passwd_hash=%userpendingboincmd5hash%
%userpendingruncomdtext% %userpendinglibcurldir%\curl.exe --output %userpendingboincauthfile% %userpendingboincsiteurl%/lookup_account.php?email_addr=%userpendingboincloginuser%^&passwd_hash=%userpendingboincmd5hash%
echo.
if [%userpendingrunflag%] neq [] (echo ^<authenticator^>test^</authenticator^>>%userpendingboincauthfile%)
rem checking to make sure the curl output file is created
if not exist %userpendingboincauthfile% echo Problem in getting authenticator code
if not exist %userpendingboincauthfile% echo Check you boinc user id and password
if not exist %userpendingboincauthfile% goto :didnotgetauth

rem checking for authencator record
FOR /f "tokens=1,2,3" %%G IN ('type %userpendingboincauthfile% ^| find /c "<authenticator>"') DO set userpendingboincauthcnt=%%G
if %userpendingboincauthcnt% equ 0 echo Problem we did not get authenticator
if %userpendingboincauthcnt% equ 0 type %userpendingboincauthfile%
if %userpendingboincauthcnt% equ 0 goto :didnotgetauth
rem if we have a authencator record set value
FOR /f "tokens=1,2,3 delims=<>" %%G IN ('type %userpendingboincauthfile% ^| find "<authenticator>"') DO set userpendingboincauthentic=%%H
if exist %userpendingboincauthfile% del %userpendingboincauthfile%
rem the boincauthentic value should be equal to the value of "Account key" under Your account
rem echo Boinc authenticator=%userpendingboincauthentic%

echo Contacting Boinc project website to get Pending list
echo.
if not exist %userpendinglibcurldir%\curl.exe echo Missing curl.exe file. Looking for it here=%userpendinglibcurldir%\curl.exe
if not exist %userpendinglibcurldir%\curl.exe goto :didnotgetauth
if [%userpendingrunflag%] neq [] echo Running a test skipping cURL
if [%userpendingrunflag%] neq [] goto :exitthis
if [%userpendingboincpendingfile%] neq [] echo Placing pending list in this file=%userpendingboincpendingfile%
if [%userpendingboincpendingfile%] neq [] echo.
echo %userpendinglibcurldir%\curl.exe %userpendingcurlpendingfile% %userpendingboincsiteurl%/pending.php?format=xml^&authenticator=%userpendingboincauthentic%
%userpendingruncomdtext% %userpendinglibcurldir%\curl.exe %userpendingcurlpendingfile% %userpendingboincsiteurl%/pending.php?format=xml^&authenticator=%userpendingboincauthentic%
echo.

if [%userpendingboincpendingfile%] equ [] goto :waitforreview
if not exist %userpendingboincpendingfile% goto :waitforreview
rem This feature is turned off temporarily

FOR /f "tokens=1,2,3 delims=<>" %%G IN ('type %userpendingboincpendingfile% ^| find /c "This feature is turned off temporarily"') DO set userpendingofflinetempcount=%%G
FOR /f "tokens=1,2,3 delims=<>" %%G IN ('type %userpendingboincpendingfile% ^| find /c "<workunitid>"') DO set userpendingworkunitcount=%%G
FOR /f "tokens=1,2,3 delims=<>" %%G IN ('type %userpendingboincpendingfile% ^| find "<total_claimed_credit>"') DO set userpendingtotal=%%H
if %userpendingofflinetempcount% GTR 0 echo Boinc webRpc export feature is turned off temporarily
if %userpendingofflinetempcount% GTR 0 echo.
if %userpendingofflinetempcount% GTR 0 goto :waitforreview
if defined userpendingboincpendingfile echo Kept XML file: %userpendingboincpendingfile%
if defined userpendingworkunitcount echo Pending Workunit count:  %userpendingworkunitcount%
if defined userpendingtotal echo Total Pending is:  %userpendingtotal%
if defined userpendingtotal echo.

:waitforreview
rem if %userpendingpauserunofbatch% gtr 0 CHOICE.exe /N /D Y /T %userpendingpauserunofbatch% /M "Pausing for output review Y/N (Pause %userpendingpauserunofbatch% secs):"
if %userpendingpauserunofbatch% gtr 0 %userpendingchoosedirectoryprogram% -d Y -n -p "Pausing for output review Y/N (Pause %userpendingpauserunofbatch% secs): "  -t Y,%userpendingpauserunofbatch%
rem if n exit
if errorlevel 2 goto :exitthis
rem if y run it again
if errorlevel 1 goto :exitthis

goto :exitthis

:processarginput
 rem waiting
rem echo Processing lookfor=%1=defvalneeded=%2=end
:: length of parse arg
set userpendingarglen=0
set userpendinglookingfor=%1
set defuserpendingparseargvalneeded=%2
set userpendingoktosetvaluetoparms=%4

:finddelim
for /f %%n in ('@echo %%userpendinglookingfor:~%userpendingarglen%^,1%%') do set userpendingparseargchardelim=%%n
rem echo chardelim=%userpendingparseargchardelim%=zyx1
set /a userpendingarglen=%userpendingarglen% + 1
if %userpendingarglen% geq 60 echo Problem have not found delimiter in less the 60 characters current arg location %userpendingarglen%
if %userpendingarglen% geq 60 goto :endit

If "%userpendingparseargchardelim%" EQU "ECHO" goto :havedelim
set userpendingparseargdelim=%userpendingparseargchardelim%
rem echo in loop argdelim=%userpendingparseargdelim%=argdelimend
goto :finddelim

:havedelim
rem echo parseargdelim=%userpendingparseargdelim%=zyx3
set userpendingarglen=0

:lengthparsearg
for /f %%n in ('@echo %%userpendinglookingfor:~%userpendingarglen%^,1%%') do set userpendingchar=%%n
rem echo %userpendingchar%
set /a userpendingarglen=%userpendingarglen% + 1
if %userpendingarglen% GTR 79 echo There is a problem did search to column 80 and did not find the delimiter=: in %userpendinglookingfor%. Exiting
if %userpendingarglen% GTR 79 echo char=%userpendingparseargchar% len=%vparsearglen% delim=%userpendingparseargdelim%
if %userpendingarglen% GTR 79 goto :eof
If "%userpendingchar%" NEQ "%userpendingparseargdelim%" goto :lengthparsearg

rem echo lookingfor=%userpendinglookingfor%=length=%userpendingarglen%=lengthend

if not defined userpendingparseargprm1 goto :skipparseargvalue2
call :processarginputcheckme checkme1 %userpendingparseargprm1%
:skipparseargvalue2
if not defined userpendingparseargprm2 goto :skipparseargvalue3
call :processarginputcheckme checkme2 %userpendingparseargprm2%
:skipparseargvalue3
if not defined userpendingparseargprm3 goto :skipparseargvalue4
call :processarginputcheckme checkme3 %userpendingparseargprm3%
:skipparseargvalue4
if not defined userpendingparseargprm4 goto :skipparseargvalue5
call :processarginputcheckme checkme4 %userpendingparseargprm4%
:skipparseargvalue5
if not defined userpendingparseargprm5 goto :skipparseargvalue6
call :processarginputcheckme checkme5 %userpendingparseargprm5%
:skipparseargvalue6
if not defined userpendingparseargprm6 goto :skipparseargvalue7
call :processarginputcheckme checkme6 %userpendingparseargprm6%
:skipparseargvalue7
if not defined userpendingparseargprm7 goto :skipparseargvalue8
call :processarginputcheckme checkme7 %userpendingparseargprm7%
:skipparseargvalue8
if not defined userpendingparseargprm8 goto :skipparseargvalue9
call :processarginputcheckme checkme8 %userpendingparseargprm8%
:skipparseargvalue9
rem echo userpendingparseargbegval=%userpendingparseargbegval%=end
if not defined userpendingparseargbegval goto :skipparseargnovalue
call set userpendingcheckmebeg=%%userpendingparseargbegval:~0,%userpendingarglen%%%
rem echo checkmebeg=%userpendingcheckmebeg%=end
if [%userpendingcheckmebeg%]==[%userpendinglookingfor%] (call set userpendingparseargbeg=%%userpendingparseargbegval:~0,%userpendingarglen%%%)
if [%userpendingcheckmebeg%]==[%userpendinglookingfor%] (call set userpendingparseargval=%%userpendingparseargbegval:~%userpendingarglen%%%)
:skipparseargnovalue
rem echo parsearg lookingfor=%userpendinglookingfor%=arglen=%userpendingarglen%=argbegval=%userpendingparseargbegval%=argbeg=%userpendingparseargbeg%=argval=%userpendingparseargval%=end

if defined userpendingparseargbeg (set userpendingoutputpart1=A value was passed for %userpendinglookingfor%)
if defined userpendingparseargbeg (set userpendingoutputpart2=value: %userpendingparseargval% )
call :processarginputdefined

if not defined userpendingparseargvalneeded (set userpendingoutputpart1=No value was passed using default %userpendinglookingfor%)
if not defined userpendingparseargvalneeded (set userpendingoutputpart2=value: %defuserpendingparseargvalneeded%)
call :processarginputnotdefined

call :eocuhtotheline

:afterprintmsg
if defined userpendingparseargvalneeded (set %3=%userpendingparseargvalneeded%)
if %userpendingoktosetvaluetoparms% NEQ  oktosetvaluetoparms goto :skipsetvalueparms
if defined userpendingparseargprgmparms (set %5=%userpendingparseargprgmparms%)
:skipsetvalueparms
(set userpendingarglen=)
(set userpendinglookingfor=)
(set defuserpendingparseargvalneeded=)
(set userpendingoktosetvaluetoparms=)
(set userpendingparseargchardelim=)
(set userpendingparseargdelim=)
(set userpendingchar=)
(set userpendingcheckmebeg=)
(set userpendingparseargbegval=)
(set userpendingparseargbeg=)
(set userpendingparseargval=)
(set userpendingparsearginputcheckmelabel=)
(set userpendingparsearginputcheckme=)
(set userpendingparseargcheckme=)
(set userpendingparseargprgmparms=)
(set userpendingparseargvalneeded=)
rem ----------------
exit /b

:processarginputcheckme
set userpendingparsearginputcheckmelabel=%1
set userpendingparsearginputcheckme=%2
 echo inputcheckmelabel=%userpendingparsearginputcheckmelabel%=inputcheckme=%userpendingparsearginputcheckme%=inputcheckmeend
call set userpendingparseargcheckme=%%userpendingparsearginputcheckme:~0,%userpendingarglen%%%
if [%userpendingparseargcheckme%]==[%userpendinglookingfor%] set userpendingparseargbegval=%userpendingparsearginputcheckme%
 echo parseargcheckme=%userpendingparseargcheckme%=lookingfor=%userpendinglookingfor%=parseargbegval=%userpendingparseargbegval%=end
rem leaving :processarginputcheckme
exit /b

:processarginputdefined
if defined userpendingparseargbeg (set userpendingparseargprgmparms=%userpendingparseargbeg%%userpendingparseargval%)
if defined userpendingparseargbeg (set userpendingparseargvalneeded=%userpendingparseargval%)
rem leaving :processarginputdefined
exit /b

:processarginputnotdefined
if not defined userpendingparseargvalneeded (set userpendingparseargprgmparms=%userpendingparsearglookingfor%%defuserpendingparseargvalneeded%)
if not defined userpendingparseargvalneeded (set userpendingparseargvalneeded=%defuserpendingparseargvalneeded%)
rem leaving :processarginputnotdefined
exit /b

:eocuhtotheline
set userpendingfillerpart1=%userpendingoutputpart1%%userpendingoutputfiller%
(call set userpendingchoppart1=%%userpendingfillerpart1:~0,%userpendingputvaluehere%%%)
set userpendingformatpart1=%userpendingchoppart1:`= %
echo %userpendingformatpart1%%userpendingoutputpart2%
rem leaving :eocuhtotheline
exit /b

:didnotgetauth
echo ERROR
rem CHOICE.exe /N /D Y /T %userpendingpauserunofbatch% /M "Pausing for output review Y/N (Pause %userpendingpauserunofbatch% secs):"
rem %userpendingchoosedirectoryprogram% -d Y -n -p "Pausing for output review Y/N (Pause %userpendingpauserunofbatch% secs): "  -t Y,%userpendingpauserunofbatch%
pause
rem if n exit
if errorlevel 2 goto :exitthis
rem if y run it again
if errorlevel 1 goto :exitthis
goto :exitthis

:reqinfo
echo ----------------
echo Command program help
echo run %currentuserpendingprogramcmd%
echo        /testrun={yes or no}
echo        /runwith={call or start}
echo        /inidirectoryfilename:{inidirectoryandfilename}
echo.
echo  You can enter only the program parms you want to change.
rem ----------------
set userpendingrunwith=call
rem i am outa here
echo Exiting

:exitthis
echo Exiting...
endlocal EnableDelayedExpansion
(set currentuserpendingprogramfulldirnquotes=)
(set currentuserpendingprogramdirectory=)
(set currentuserpendingprogramnopath=)
(set currentuserpendingprogramfull=)
(set currentuserpendingprogram=)
(set currentuserpendingprogramvbs=)
(set currentuserpendingprogramcmd=)

(set defuserpendinglibcurldir=)
(set userpendinglibcurldir=)
(set defuserpendingboincsiteurl=)
(set userpendingboincsiteurl=)
(set defuserpendingboincloginuser=)
(set userpendingboincloginuser=)
(set defuserpendingboincloginpassword=)
(set userpendingboincloginpassword=)
(set defuserpendingmd5directoryprogram=)
(set userpendingmd5directoryprogram=)
(set userpendingmd5programoptions=)
(set userpendingmd5programrun=)
(set defuserpendingchoosedirectoryprogram=)
(set userpendingchoosedirectoryprogram=)
(set userpendingchooseprogramoptions=)
(set userpendingshooseprogramrun=)
(set defuserpendingboincauthfile=)
(set userpendingboincauthfile=)
(set defuserpendingboincpendingfile=)
(set userpendingboincpendingfile=)
(set userpendingcurlpendingfile=)
(set defuserpendinginidirectoryfilename=)
(set userpendingoutputfiller=)
(set userpendingputvaluehere=)
(set defuserpendingstoprun=)
(set defuserpendingpauserunofbatch=)
(set userpendingpauserunofbatch=)
(set defuserpendingrunwith=)
(set defuserpendingtestrun=)
(set userpendingruncomdtext=)
(set userpendingrunflag=)

(set userpendingparseargprm1=)
(set userpendingparseargprm2=)
(set userpendingparseargprm3=)
(set userpendingparseargprm4=)
(set userpendingparseargprm5=)
(set userpendingparseargprm6=)

(set userpendinginidirectoryfilename=)
(set userpendingprgmparms1=)
rem (set userpendingrunwith=)
(set userpendingprgmparms2=)
(set userpendingtestrun=)
(set userpendingprgmparms3=)

(set userpendingcontroltempini=)
(set userpendingstoprun=)

(set userpendingboincmd5hash=)
(set userpendingboincauthcnt=)
(set userpendingboincauthentic=)

(set userpendingarglen=)
(set userpendinglookingfor=)
(set defuserpendingparseargvalneeded=)
(set userpendingoktosetvaluetoparms=)
(set userpendingparseargchardelim=)
(set userpendingparseargdelim=)
(set userpendingchar=)
(set userpendingcheckmebeg=)
(set userpendingparseargbegval=)
(set userpendingparseargbeg=)
(set userpendingparseargval=)
(set userpendingparsearginputcheckmelabel=)
(set userpendingparsearginputcheckme=)
(set userpendingparseargcheckme=)
(set userpendingparseargprgmparms=)
(set userpendingparseargvalneeded=)

(set userpendingoutputpart1=)
(set userpendingoutputpart2=)
(set userpendingchoppart1=)
(set userpendingfillerpart1=)
(set userpendingformatpart1=)

(set processinginifound=)

(set userpendingtotal=)

:: exit area
if [%userpendingrunwith%] equ [start] goto :exitwhenrunwithstart
goto :exitwhenrunwithnostart
:exitwhenrunwithstart
(set userpendingrunwith=)
exit
:exitwhenrunwithnostart
(set userpendingrunwith=)
goto :eof

:processitini
rem echo processitini area %1 %2
if %1==rem goto :eof

rem stoprun
rem if defined userpendingstoprun goto :nextcontroliniitem2
set userpendingprocessinginifound=no
rem if not [%1]==[stoprun] goto :nextcontroliniitem2
if [%1]==[stoprun] call :processcontroliniitems  %1 %defuserpendingstoprun% %2 userpendingstoprun
if [%1]==[stoprun] set userpendingprocessinginifound=yes
if [%1]==[libcurldir] call :processcontroliniitems  %1 %defuserpendinglibcurldir% %2 userpendinglibcurldir
if [%1]==[libcurldir] set userpendingprocessinginifound=yes
if [%1]==[boincsiteurl] call :processcontroliniitems  %1 %defuserpendingboincsiteurl% %2 userpendingboincsiteurl
if [%1]==[boincsiteurl] set userpendingprocessinginifound=yes
if [%1]==[boincloginuser] call :processcontroliniitems  %1 %defuserpendingboincloginuser% %2 userpendingboincloginuser
if [%1]==[boincloginuser] set userpendingprocessinginifound=yes
if [%1]==[boincloginpassword] call :processcontroliniitems  %1 %defuserpendingboincloginpassword% %2 userpendingboincloginpassword
if [%1]==[boincloginpassword] set userpendingprocessinginifound=yes
if [%1]==[md5directoryprogram] call :processcontroliniitems  %1 %defuserpendingmd5directoryprogram% %2 userpendingmd5directoryprogram
if [%1]==[md5directoryprogram] set userpendingprocessinginifound=yes
if [%1]==[choosedirectoryprogram] call :processcontroliniitems  %1 %defuserpendingchoosedirectoryprogram% %2 userpendingchoosedirectoryprogram
if [%1]==[choosedirectoryprogram] set userpendingprocessinginifound=yes
if [%1]==[boincauthfile] call :processcontroliniitems  %1 %defuserpendingboincauthfile% %2 userpendingboincauthfile
if [%1]==[boincauthfile] set userpendingprocessinginifound=yes
if [%1]==[boincpendingfile] call :processcontroliniitems  %1 %defuserpendingboincpendingfile% %2 userpendingboincpendingfile
if [%1]==[boincpendingfile] set userpendingprocessinginifound=yes
if [%1]==[pauserunofbatch] call :processcontroliniitems  %1 %defuserpendingpauserunofbatch% %2 userpendingpauserunofbatch
if [%1]==[pauserunofbatch] set userpendingprocessinginifound=yes
if [%userpendingprocessinginifound%] equ [no] echo This %1 was not processed
exit /b

:processcontroliniitems
rem echo processcontroliniitems area ini1=%1=ini2=%2=3=%3=4=%4=end
if [%3] NEQ [] (set userpendingoutputpart1=A value was read from ini for %1)
if [%3] NEQ [] (set %4=%3)
if [%3] NEQ [] (set userpendingoutputpart2=value: %3)
if [%3] EQU [] (set userpendingoutputpart1=No value read from ini using default %1)
if [%3] EQU [] (set %4=%2)
if [%3] EQU [] (set userpendingoutputpart2=value: %2)
call :eocuhtotheline
rem ----------------
exit /b